"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EpicApplication = void 0;
const express_1 = __importDefault(require("express"));
const helpers_1 = require("./helpers");
class EpicApplication {
    constructor(options, Framework = express_1.default()) {
        this.Framework = Framework;
        /**
         * Before the server initializes
         * This method let you configure the middleware required by your application to works.
         *
         */
        this._beforeInit = (_Server) => { };
        /**
         * When the server starts listening
         * Do something when the server starts listening...
         *
         */
        this._onInit = (Server) => {
            // Log Server Initialization
            console.log(`Server is listening at Port: ${Server.Port}.`);
        };
        /**
         * When the server starts listening
         * Do something when the server starts listening...
         *
         */
        this._onRouteError = (err, _req, res) => {
            // Set Error Status
            res.status(500);
            // Return Response Object
            return new helpers_1.CreateResponse(err);
        };
        /**
         *
         * Error occured while starting the server
         * Do something if there was an error while starting the server.
         *
         */
        this._onError = (error, _Server) => {
            // Log Error
            console.error(error);
            // Exit Application
            process.exit(1);
        };
        this._beforeInit = (options === null || options === void 0 ? void 0 : options._beforeInit) || this._beforeInit;
        this._onInit = (options === null || options === void 0 ? void 0 : options._onInit) || this._onInit;
        this._onRouteError = (options === null || options === void 0 ? void 0 : options._onRouteError) || this._onRouteError;
        this._onError = (options === null || options === void 0 ? void 0 : options._onError) || this._onError;
    }
}
exports.EpicApplication = EpicApplication;
