import { Request, Response, NextFunction } from "express";
export interface ValidationMessage {
    param?: string;
    location?: string;
    message: string;
    value?: any;
}
export interface DefaultResponse<B extends boolean, T> {
    status: B;
    messages: Array<ValidationMessage>;
    data: T;
    code: number;
}
export declare class CreateResponse {
    protected Message: string;
    protected Data?: any;
    protected Status: boolean;
    protected Code?: number;
    constructor(Message: string, Data?: any);
    isFalse(): this;
    setCode(code: number): this;
    render(): readonly [boolean, string, any, number | undefined];
}
export declare type RequestHandlerReturnType = CreateResponse | string | void;
export declare type RequestHandler = (req: Request<any, any, any, any, any>, res: Response<any, any>, next: NextFunction) => Promise<RequestHandlerReturnType> | RequestHandlerReturnType;
export declare type RequestErrorHandler = (err: any, req: Request<any, any, any, any, any>, res: Response<any, any>) => Promise<RequestHandlerReturnType> | RequestHandlerReturnType;
export declare class EpicHelpers {
    static requestHandler(Handler: RequestHandler): (req: Request, res: Response, next: NextFunction) => Promise<void>;
    static requestErrorHandler(Handler: RequestErrorHandler): (err: any, req: Request, res: Response, _next: NextFunction) => Promise<void>;
    static response<B extends boolean, T>(status: B, messages: string | ValidationMessage | ValidationMessage[], data?: T, code?: number): Promise<DefaultResponse<B, T>>;
}
