"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EpicHelpers = exports.CreateResponse = void 0;
class CreateResponse {
    constructor(Message, Data) {
        this.Message = Message;
        this.Data = Data;
        this.Status = true;
    }
    isFalse() {
        this.Status = false;
        return this;
    }
    setCode(code) {
        this.Code = code;
        return this;
    }
    render() {
        return [this.Status, this.Message, this.Data, this.Code];
    }
}
exports.CreateResponse = CreateResponse;
class EpicHelpers {
    static requestHandler(Handler) {
        // Return Middleware
        return (req, res, next) => __awaiter(this, void 0, void 0, function* () {
            try {
                // Process Controller Operations
                const Results = yield Handler(req, res, next);
                if (Results)
                    // Return Response
                    res.json(yield this.response(...(Results instanceof CreateResponse
                        ? Results
                        : new CreateResponse(Results)).render()));
            }
            catch (error) {
                next(error);
            }
        });
    }
    static requestErrorHandler(Handler) {
        // Return Middleware
        return (err, req, res, _next) => __awaiter(this, void 0, void 0, function* () {
            // Process Controller Operations
            const TempResults = yield Handler(err, req, res);
            // Resolve Results
            const Results = (TempResults instanceof CreateResponse
                ? TempResults
                : new CreateResponse(TempResults || "An unexpected error has been encountered!")).render();
            // Return Response
            res.json(yield this.response(false, Results[1], Results[2] || (process.env.NODE_ENV === "development" ? err : {}), Results[3]));
        });
    }
    static response(status, messages, data, code) {
        return __awaiter(this, void 0, void 0, function* () {
            // Resolve Messages
            if (typeof messages !== "object" && typeof messages !== "string")
                messages = status
                    ? "The request was successful!"
                    : "The request was failed!";
            // Format the Message
            if (typeof messages === "string")
                messages = { message: messages };
            else if (messages instanceof Error)
                messages = { message: messages.message };
            // Return Data
            return {
                status,
                messages: messages instanceof Array ? messages : [messages],
                data: data || {},
                code: code || (status ? 0 : 1),
            };
        });
    }
}
exports.EpicHelpers = EpicHelpers;
