/// <reference types="node" />
import http from "http";
import https from "https";
import Debug from "debug";
import { HTTPBase } from "./http-base";
import { EpicApplication } from "./application";
/**
 *
 * HTTP Server
 * This class will create an instance of HTTP Server.
 *
 */
export declare class HTTP extends HTTPBase {
    constructor(Application: EpicApplication, ServerOptions?: Parameters<typeof http.createServer>[0], Debugger?: Debug.Debugger);
}
/**
 *
 * HTTPS Server
 * This class will create an instance of HTTPS Server.
 *
 */
export declare class HTTPS extends HTTPBase {
    Server: https.Server;
    constructor(Application: EpicApplication, ServerOptions?: Parameters<typeof https.createServer>[0], Debugger?: Debug.Debugger);
}
