"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HTTPS = exports.HTTP = void 0;
const http_1 = __importDefault(require("http"));
const https_1 = __importDefault(require("https"));
const debug_1 = __importDefault(require("debug"));
const http_base_1 = require("./http-base");
/**
 *
 * HTTP Server
 * This class will create an instance of HTTP Server.
 *
 */
class HTTP extends http_base_1.HTTPBase {
    constructor(Application, ServerOptions, Debugger = debug_1.default("Epic:Server")) {
        super(Application, http_1.default.createServer(ServerOptions || {}, Application.Framework), Debugger);
    }
}
exports.HTTP = HTTP;
/**
 *
 * HTTPS Server
 * This class will create an instance of HTTPS Server.
 *
 */
class HTTPS extends http_base_1.HTTPBase {
    constructor(Application, ServerOptions, Debugger = debug_1.default("Epic:Server")) {
        super(Application, https_1.default.createServer(ServerOptions || {}, Application.Framework), Debugger);
    }
}
exports.HTTPS = HTTPS;
