import { Router } from "express";

export interface HandlerDetails {
  name: string;
  description: string;
}

export class EpicGlobals {
  private static Router: Router;
  private static RouteDetails: HandlerDetails[] = [];

  static getRouter() {
    if (!this.Router) this.Router = Router();
    return this.Router;
  }

  static setRouter(Router: Router) {
    this.Router = Router;
    return this;
  }

  static pushRouteDetails(details: HandlerDetails) {
    this.RouteDetails.push(details);
    return this;
  }

  static getRouteDetails() {
    return this.RouteDetails;
  }
}
